//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "LockFuses.h"          //    LockFusesForm
#include "ChipFunctions.h"      //     
#include "FormFunctions.h"      //     
#include "Main.h"               //      
#include "LogFunctions.h"       //      
#include "ProgressBar.h"        //   -
#include "PICFunctions.h"       //       PIC
#include "pic16f630.h"          //      PIC16F630 / PIC16F676
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TLockFusesForm *LockFusesForm;
//---------------------------------------------------------------------------
//---    -------------------------------------------
//---------------------------------------------------------------------------
void IniteAllCheckboxes()
{ LockFusesForm->Panel1->Visible        = false;        //     
  //    
  LockFusesForm->GroupBox1->Visible     = false;        //    0
  LockFusesForm->GroupBox2->Visible     = false;        //    1
  LockFusesForm->GroupBox3->Visible     = false;        //    2
  LockFusesForm->GroupBox4->Visible     = false;        //    3
  //    
  LockFusesForm->CheckBox1->Visible     = false;        //    0  0
  LockFusesForm->CheckBox2->Visible     = false;        //    1  0
  LockFusesForm->CheckBox3->Visible     = false;        //    2  0
  LockFusesForm->CheckBox4->Visible     = false;        //    3  0
  LockFusesForm->CheckBox5->Visible     = false;        //    4  0
  LockFusesForm->CheckBox6->Visible     = false;        //    5  0
  LockFusesForm->CheckBox7->Visible     = false;        //    6  0
  LockFusesForm->CheckBox8->Visible     = false;        //    7  0
  LockFusesForm->CheckBox9->Visible     = false;        //    0  1
  LockFusesForm->CheckBox10->Visible    = false;        //    1  1
  LockFusesForm->CheckBox11->Visible    = false;        //    2  1
  LockFusesForm->CheckBox12->Visible    = false;        //    3  1
  LockFusesForm->CheckBox13->Visible    = false;        //    4  1
  LockFusesForm->CheckBox14->Visible    = false;        //    5  1
  LockFusesForm->CheckBox15->Visible    = false;        //    6  1
  LockFusesForm->CheckBox16->Visible    = false;        //    7  1
  LockFusesForm->CheckBox17->Visible    = false;        //    0  2
  LockFusesForm->CheckBox18->Visible    = false;        //    1  2
  LockFusesForm->CheckBox19->Visible    = false;        //    2  2
  LockFusesForm->CheckBox20->Visible    = false;        //    3  2
  LockFusesForm->CheckBox21->Visible    = false;        //    4  2
  LockFusesForm->CheckBox22->Visible    = false;        //    5  2
  LockFusesForm->CheckBox23->Visible    = false;        //    6  2
  LockFusesForm->CheckBox24->Visible    = false;        //    7  2
  LockFusesForm->CheckBox25->Visible    = false;        //    0  3
  LockFusesForm->CheckBox26->Visible    = false;        //    1  3
  LockFusesForm->CheckBox27->Visible    = false;        //    2  3
  LockFusesForm->CheckBox28->Visible    = false;        //    3  3
  LockFusesForm->CheckBox29->Visible    = false;        //    4  3
  LockFusesForm->CheckBox30->Visible    = false;        //    5  3
  LockFusesForm->CheckBox31->Visible    = false;        //    6  3
  LockFusesForm->CheckBox32->Visible    = false;        //    7  3
  //     
  UncheckAllCheckboxes();
  //   
  LockFusesForm->CheckBox1->Enabled     = true;         //   0  0
  LockFusesForm->CheckBox2->Enabled     = true;         //   1  0
  LockFusesForm->CheckBox3->Enabled     = true;         //   2  0
  LockFusesForm->CheckBox4->Enabled     = true;         //   3  0
  LockFusesForm->CheckBox5->Enabled     = true;         //   4  0
  LockFusesForm->CheckBox6->Enabled     = true;         //   5  0
  LockFusesForm->CheckBox7->Enabled     = true;         //   6  0
  LockFusesForm->CheckBox8->Enabled     = true;         //   7  0
  LockFusesForm->CheckBox9->Enabled     = true;         //   0  1
  LockFusesForm->CheckBox10->Enabled    = true;         //   1  1
  LockFusesForm->CheckBox11->Enabled    = true;         //   2  1
  LockFusesForm->CheckBox12->Enabled    = true;         //   3  1
  LockFusesForm->CheckBox13->Enabled    = true;         //   4  1
  LockFusesForm->CheckBox14->Enabled    = true;         //   5  1
  LockFusesForm->CheckBox15->Enabled    = true;         //   6  1
  LockFusesForm->CheckBox16->Enabled    = true;         //   7  1
  LockFusesForm->CheckBox17->Enabled    = true;         //   0  2
  LockFusesForm->CheckBox18->Enabled    = true;         //   1  2
  LockFusesForm->CheckBox19->Enabled    = true;         //   2  2
  LockFusesForm->CheckBox20->Enabled    = true;         //   3  2
  LockFusesForm->CheckBox21->Enabled    = true;         //   4  2
  LockFusesForm->CheckBox22->Enabled    = true;         //   5  2
  LockFusesForm->CheckBox23->Enabled    = true;         //   6  2
  LockFusesForm->CheckBox24->Enabled    = true;         //   7  2
  LockFusesForm->CheckBox25->Enabled    = true;         //   0  3
  LockFusesForm->CheckBox26->Enabled    = true;         //   1  3
  LockFusesForm->CheckBox27->Enabled    = true;         //   2  3
  LockFusesForm->CheckBox28->Enabled    = true;         //   3  3
  LockFusesForm->CheckBox29->Enabled    = true;         //   4  3
  LockFusesForm->CheckBox30->Enabled    = true;         //   5  3
  LockFusesForm->CheckBox31->Enabled    = true;         //   6  3
  LockFusesForm->CheckBox32->Enabled    = true;         //   7  3
}
//---------------------------------------------------------------------------
//---      -------------------------------------
//---------------------------------------------------------------------------
void UncheckAllCheckboxes()
{ LockFusesForm->CheckBox1->Checked     = false;        //     0  0
  LockFusesForm->CheckBox2->Checked     = false;        //     1  0
  LockFusesForm->CheckBox3->Checked     = false;        //     2  0
  LockFusesForm->CheckBox4->Checked     = false;        //     3  0
  LockFusesForm->CheckBox5->Checked     = false;        //     4  0
  LockFusesForm->CheckBox6->Checked     = false;        //     5  0
  LockFusesForm->CheckBox7->Checked     = false;        //     6  0
  LockFusesForm->CheckBox8->Checked     = false;        //     7  0
  LockFusesForm->CheckBox9->Checked     = false;        //     0  1
  LockFusesForm->CheckBox10->Checked    = false;        //     1  1
  LockFusesForm->CheckBox11->Checked    = false;        //     2  1
  LockFusesForm->CheckBox12->Checked    = false;        //     3  1
  LockFusesForm->CheckBox13->Checked    = false;        //     4  1
  LockFusesForm->CheckBox14->Checked    = false;        //     5  1
  LockFusesForm->CheckBox15->Checked    = false;        //     6  1
  LockFusesForm->CheckBox16->Checked    = false;        //     7  1
  LockFusesForm->CheckBox17->Checked    = false;        //     0  2
  LockFusesForm->CheckBox18->Checked    = false;        //     1  2
  LockFusesForm->CheckBox19->Checked    = false;        //     2  2
  LockFusesForm->CheckBox20->Checked    = false;        //     3  2
  LockFusesForm->CheckBox21->Checked    = false;        //     4  2
  LockFusesForm->CheckBox22->Checked    = false;        //     5  2
  LockFusesForm->CheckBox23->Checked    = false;        //     6  2
  LockFusesForm->CheckBox24->Checked    = false;        //     7  2
  LockFusesForm->CheckBox25->Checked    = false;        //     0  3
  LockFusesForm->CheckBox26->Checked    = false;        //     1  3
  LockFusesForm->CheckBox27->Checked    = false;        //     2  3
  LockFusesForm->CheckBox28->Checked    = false;        //     3  3
  LockFusesForm->CheckBox29->Checked    = false;        //     4  3
  LockFusesForm->CheckBox30->Checked    = false;        //     5  3
  LockFusesForm->CheckBox31->Checked    = false;        //     6  3
  LockFusesForm->CheckBox32->Checked    = false;        //     7  3
}
//---------------------------------------------------------------------------
//---   (   ) ------------------------
//---------------------------------------------------------------------------
__fastcall TLockFusesForm::TLockFusesForm(TComponent* Owner)
        : TForm(Owner)
{ IniteAllCheckboxes();  //    
  //         
  switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
  { case 0x2080:        //   PIC16F887
    case 0x2060:        //   PIC16F886
    case 0x2040:        //   PIC16F884
    case 0x2020:        //   PIC16F883
    case 0x2000:        //   PIC16F882
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7 W1";         //  0     1
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13 W1";        //  1     1
                        LockFusesForm->GroupBox3->Caption     = "bits 0..7 W2";         //  2     2
                        LockFusesForm->GroupBox4->Caption     = "bits 8..13 W2";        //  3     2
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        LockFusesForm->GroupBox3->Visible     = true;           //   2
                        LockFusesForm->GroupBox4->Visible     = true;           //   3
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   2  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                        LockFusesForm->CheckBox8->Caption     = "!CPD";         //   7  0
                        LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "IESO";         //   2  1
                        LockFusesForm->CheckBox12->Caption    = "FCMEN";        //   3  1
                        LockFusesForm->CheckBox13->Caption    = "LVP";          //   4  1
                        LockFusesForm->CheckBox14->Caption    = "!DEBUG";       //   5  1
                        LockFusesForm->CheckBox25->Caption    = "BOR4V";        //   0  3
                        LockFusesForm->CheckBox26->Caption    = "WRT0";         //   1  3
                        LockFusesForm->CheckBox27->Caption    = "WRT1";         //   2  3
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox12->Visible    = true;           //   3  1
                        LockFusesForm->CheckBox13->Visible    = true;           //   4  1
                        LockFusesForm->CheckBox14->Visible    = true;           //   5  1
                        LockFusesForm->CheckBox25->Visible    = true;           //   0  3
                        LockFusesForm->CheckBox26->Visible    = true;           //   1  3
                        LockFusesForm->CheckBox27->Visible    = true;           //   2  3
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 441;
                        break;
    case 0x1C60:        //   PIC16LF721
    case 0x1C20:        //   PIC16F721
    case 0x1C40:        //   PIC16LF720
    case 0x1C00:        //   PIC16F720
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7 W1";         //  0     1
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13 W1";        //  1     1
                        LockFusesForm->GroupBox3->Caption     = "bits 0..7 W2";         //  2     2
                        LockFusesForm->GroupBox4->Caption     = "bits 8..13 W2";        //  3     2
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        LockFusesForm->GroupBox3->Visible     = true;           //   2
                        LockFusesForm->GroupBox4->Visible     = true;           //   3
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                        LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                        LockFusesForm->CheckBox13->Caption    = "PLLEN";        //   4  1
                        LockFusesForm->CheckBox14->Caption    = "!DEBUG";       //   5  1
                        LockFusesForm->CheckBox17->Caption    = "WRT0";         //   0  2
                        LockFusesForm->CheckBox18->Caption    = "WRT1";         //   1  2
                        LockFusesForm->CheckBox21->Caption    = "VCAPEN";       //   4  2
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox13->Visible    = true;           //   4  1
                        LockFusesForm->CheckBox14->Visible    = true;           //   5  1
                        LockFusesForm->CheckBox17->Visible    = true;           //   0  2
                        LockFusesForm->CheckBox18->Visible    = true;           //   1  2
                        LockFusesForm->CheckBox21->Visible    = true;           //   4  2
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 441;
                        break;
    case 0x1900:        //   PIC16LF727
    case 0x1800:        //   PIC16F727
    case 0x1940:        //   PIC16LF724
    case 0x1840:        //   PIC16F724
    case 0x1920:        //   PIC16LF726
    case 0x1820:        //   PIC16F726
    case 0x1B40:        //   PIC16LF723A
    case 0x1B00:        //   PIC16F723A
    case 0x1960:        //   PIC16LF723
    case 0x1860:        //   PIC16F723
    case 0x1B60:        //   PIC16LF722A
    case 0x1B20:        //   PIC16F722A
    case 0x1980:        //   PIC16LF722
    case 0x1880:        //   PIC16F722
    case 0x1AE0:        //   PIC16LF707
    case 0x1AC0:        //   PIC16F707
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7 W1";         //  0     1
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13 W1";        //  1     1
                        LockFusesForm->GroupBox3->Caption     = "bits 0..7 W2";         //  2     2
                        LockFusesForm->GroupBox4->Caption     = "bits 8..13 W2";        //  3     2
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        LockFusesForm->GroupBox3->Visible     = true;           //   2
                        LockFusesForm->GroupBox4->Visible     = true;           //   3
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   1  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                        LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "BORV";         //   2  1
                        LockFusesForm->CheckBox13->Caption    = "PLLEN";        //   4  1
                        LockFusesForm->CheckBox14->Caption    = "!DEBUG";       //   5  1
                        LockFusesForm->CheckBox21->Caption    = "VCAPEN0";      //   4  2
                        LockFusesForm->CheckBox22->Caption    = "VCAPEN1";      //   5  2
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox13->Visible    = true;           //   4  1
                        LockFusesForm->CheckBox14->Visible    = true;           //   5  1
                        LockFusesForm->CheckBox21->Visible    = true;           //   4  2
                        LockFusesForm->CheckBox22->Visible    = true;           //   5  2
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 441;
                        break;
    case 0x1100:        //   PIC16F648A
    case 0x1060:        //   PIC16F628A
    case 0x1040:        //   PIC16F627A
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7";            //  0
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13";           //  1
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "WDTE";         //   2  0
                        LockFusesForm->CheckBox4->Caption     = "!PWRTE";       //   3  0
                        LockFusesForm->CheckBox5->Caption     = "FOSC2";        //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "BOREN";        //   6  0
                        LockFusesForm->CheckBox8->Caption     = "LVP";          //   7  0
                        LockFusesForm->CheckBox9->Caption     = "!CPD";         //   0  1
                        LockFusesForm->CheckBox14->Caption    = "!CP";          //   5  1
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox14->Visible    = true;           //   5  1
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 219;
                        break;
    case 0x14A0:        //   PIC16LF1847
    case 0x1480:        //   PIC16F1847
    case 0x1BC0:        //   PIC12LF1840
    case 0x1B80:        //   PIC12F1840
    case 0x28E0:        //   PIC16LF1829
    case 0x27E0:        //   PIC16F1829
    case 0x28C0:        //   PIC16LF1828
    case 0x27C0:        //   PIC16F1828
    case 0x28A0:        //   PIC16LF1827
    case 0x27A0:        //   PIC16F1827
    case 0x2880:        //   PIC16LF1826
    case 0x2780:        //   PIC16F1826
    case 0x2860:        //   PIC16LF1825
    case 0x2760:        //   PIC16F1825
    case 0x2840:        //   PIC16LF1824
    case 0x2740:        //   PIC16F1824
    case 0x2820:        //   PIC16LF1823
    case 0x2720:        //   PIC16F1823
    case 0x2800:        //   PIC12LF1822
    case 0x2700:        //   PIC12F1822
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7 W1";         //  0     1
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13 W1";        //  1     1
                        LockFusesForm->GroupBox3->Caption     = "bits 0..7 W2";         //  2     2
                        LockFusesForm->GroupBox4->Caption     = "bits 8..13 W2";        //  3     2
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        LockFusesForm->GroupBox3->Visible     = true;           //   2
                        LockFusesForm->GroupBox4->Visible     = true;           //   3
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   1  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE0";        //   3  0
                        LockFusesForm->CheckBox5->Caption     = "WDTE1";        //   4  0
                        LockFusesForm->CheckBox6->Caption     = "!PWRTE";       //   5  0
                        LockFusesForm->CheckBox7->Caption     = "MCLRE";        //   6  0
                        LockFusesForm->CheckBox8->Caption     = "!CP";          //   7  0
                        LockFusesForm->CheckBox9->Caption     = "!CPD";         //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN0";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "BOREN1";       //   2  1
                        LockFusesForm->CheckBox12->Caption    = "!CLKOUTEN";    //   3  1
                        LockFusesForm->CheckBox13->Caption    = "IESO";         //   4  1
                        LockFusesForm->CheckBox14->Caption    = "FCMEN";        //   5  1
                        LockFusesForm->CheckBox17->Caption    = "WRT0";         //   0  2
                        LockFusesForm->CheckBox18->Caption    = "WRT1";         //   1  2
                        LockFusesForm->CheckBox25->Caption    = "PLLEN";        //   0  3
                        LockFusesForm->CheckBox26->Caption    = "STVREN";       //   1  3
                        LockFusesForm->CheckBox27->Caption    = "BORV";         //   2  3
                        LockFusesForm->CheckBox29->Caption    = "!DEBUG";       //   4  3
                        LockFusesForm->CheckBox30->Caption    = "LVP";          //   5  3
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox12->Visible    = true;           //   4  1
                        LockFusesForm->CheckBox13->Visible    = true;           //   5  1
                        LockFusesForm->CheckBox14->Visible    = true;           //   3  1
                        LockFusesForm->CheckBox17->Visible    = true;           //   0  2
                        LockFusesForm->CheckBox18->Visible    = true;           //   1  2
                        LockFusesForm->CheckBox25->Visible    = true;           //   0  3
                        LockFusesForm->CheckBox26->Visible    = true;           //   1  3
                        LockFusesForm->CheckBox27->Visible    = true;           //   2  3
                        LockFusesForm->CheckBox29->Visible    = true;           //   4  3
                        LockFusesForm->CheckBox30->Visible    = true;           //   5  3
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 441;
                        break;
    case 0x1360:        //   PIC12F617
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7";            //  0
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13";           //  1
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   2  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                        LockFusesForm->CheckBox8->Caption     = "IOSCFS";       //   7  0
                        LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "WRT0";         //   2  1
                        LockFusesForm->CheckBox12->Caption    = "WRT1";         //   3  1
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox12->Visible    = true;           //   3  1
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 219;
                        break;
    case 0x1240:        //   PIC16F616
    case 0x2260:        //   PIC16F610
    case 0x2240:        //   PIC12F609
    case 0x2180:        //   PIC12F615
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7";            //  0
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13";           //  1
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   2  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                        LockFusesForm->CheckBox8->Caption     = "IOSCFS";       //   7  0
                        LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 219;
                        break;
    case 0x2E00:        //   PIC16LF1509
    case 0x2D40:        //   PIC16F1509
    case 0x2DE0:        //   PIC16LF1508
    case 0x2D20:        //   PIC16F1508
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7 W1";         //  0     1
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13 W1";        //  1     1
                        LockFusesForm->GroupBox3->Caption     = "bits 0..7 W2";         //  2     2
                        LockFusesForm->GroupBox4->Caption     = "bits 8..13 W2";        //  3     2
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        LockFusesForm->GroupBox3->Visible     = true;           //   2
                        LockFusesForm->GroupBox4->Visible     = true;           //   3
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   2  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE0";        //   3  0
                        LockFusesForm->CheckBox5->Caption     = "WDTE1";        //   4  0
                        LockFusesForm->CheckBox6->Caption     = "!PWRTE";       //   5  0
                        LockFusesForm->CheckBox7->Caption     = "MCLRE";        //   6  0
                        LockFusesForm->CheckBox8->Caption     = "!CP";          //   7  0
                        LockFusesForm->CheckBox10->Caption    = "BOREN0";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "BOREN1";       //   2  1
                        LockFusesForm->CheckBox12->Caption    = "!CLKOUTEN";    //   3  1
                        LockFusesForm->CheckBox13->Caption    = "IESO";         //   4  1
                        LockFusesForm->CheckBox14->Caption    = "FCMEN";        //   5  1
                        LockFusesForm->CheckBox17->Caption    = "WRT0";         //   0  2
                        LockFusesForm->CheckBox18->Caption    = "WRT1";         //   1  2
                        LockFusesForm->CheckBox26->Caption    = "STVREN";       //   1  3
                        LockFusesForm->CheckBox27->Caption    = "BORV";         //   2  3
                        LockFusesForm->CheckBox28->Caption    = "!LPBOR";       //   3  3
                        LockFusesForm->CheckBox29->Caption    = "!DEBUG";       //   4  3
                        LockFusesForm->CheckBox30->Caption    = "LVP";          //   5  3
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox12->Visible    = true;           //   3  1
                        LockFusesForm->CheckBox13->Visible    = true;           //   4  1
                        LockFusesForm->CheckBox14->Visible    = true;           //   5  1
                        LockFusesForm->CheckBox17->Visible    = true;           //   0  2
                        LockFusesForm->CheckBox18->Visible    = true;           //   1  2
                        LockFusesForm->CheckBox26->Visible    = true;           //   1  3
                        LockFusesForm->CheckBox27->Visible    = true;           //   2  3
                        LockFusesForm->CheckBox28->Visible    = true;           //   3  3
                        LockFusesForm->CheckBox29->Visible    = true;           //   4  3
                        LockFusesForm->CheckBox30->Visible    = true;           //   5  3
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 441;
                        break;
    case 0x2DC0:        //   PIC16LF1507
    case 0x2D00:        //   PIC16F1507
    case 0x2DA0:        //   PIC16LF1503
    case 0x2CE0:        //   PIC16F1503
    case 0x2D80:        //   PIC12LF1501
    case 0x2CC0:        //   PIC12F1501
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7 W1";         //  0     1
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13 W1";        //  1     1
                        LockFusesForm->GroupBox3->Caption     = "bits 0..7 W2";         //  2     2
                        LockFusesForm->GroupBox4->Caption     = "bits 8..13 W2";        //  3     2
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        LockFusesForm->GroupBox3->Visible     = true;           //   2
                        LockFusesForm->GroupBox4->Visible     = true;           //   3
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE0";        //   3  0
                        LockFusesForm->CheckBox5->Caption     = "WDTE1";        //   4  0
                        LockFusesForm->CheckBox6->Caption     = "!PWRTE";       //   5  0
                        LockFusesForm->CheckBox7->Caption     = "MCLRE";        //   6  0
                        LockFusesForm->CheckBox8->Caption     = "!CP";          //   7  0
                        LockFusesForm->CheckBox10->Caption    = "BOREN0";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "BOREN1";       //   2  1
                        LockFusesForm->CheckBox12->Caption    = "!CLKOUTEN";    //   3  1
                        LockFusesForm->CheckBox17->Caption    = "WRT0";         //   0  2
                        LockFusesForm->CheckBox18->Caption    = "WRT1";         //   1  2
                        LockFusesForm->CheckBox26->Caption    = "STVREN";       //   1  3
                        LockFusesForm->CheckBox27->Caption    = "BORV";         //   2  3
                        LockFusesForm->CheckBox28->Caption    = "!LPBOR";       //   3  3
                        LockFusesForm->CheckBox30->Caption    = "LVP";          //   5  3
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox12->Visible    = true;           //   3  1
                        LockFusesForm->CheckBox17->Visible    = true;           //   0  2
                        LockFusesForm->CheckBox18->Visible    = true;           //   1  2
                        LockFusesForm->CheckBox26->Visible    = true;           //   1  3
                        LockFusesForm->CheckBox27->Visible    = true;           //   2  3
                        LockFusesForm->CheckBox28->Visible    = true;           //   3  3
                        LockFusesForm->CheckBox30->Visible    = true;           //   5  3
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 441;
                        break;
    case 0x3020:     //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       //   
                                LockFusesForm->GroupBox1->Caption     = "bits 0..7";            //  0
                                LockFusesForm->GroupBox2->Caption     = "bits 8..13";           //  1
                                //   
                                LockFusesForm->GroupBox1->Visible     = true;           //   0
                                LockFusesForm->GroupBox2->Visible     = true;           //   1
                                //   
                                LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                                LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                                LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                                LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                                LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                                LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                                LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                                LockFusesForm->CheckBox11->Caption    = "WRT0";         //   2  1
                                LockFusesForm->CheckBox12->Caption    = "WRT1";         //   3  1
                                LockFusesForm->CheckBox13->Caption    = "!CLKOUTEN";    //   4  1
                                LockFusesForm->CheckBox14->Caption    = "!DEBUG";       //   5  1
                                //   
                                LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                                LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                                LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                                LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                                LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                                LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                                LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                                LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                                LockFusesForm->CheckBox12->Visible    = true;           //   3  1
                                LockFusesForm->CheckBox13->Visible    = true;           //   4  1
                                LockFusesForm->CheckBox14->Visible    = true;           //   5  1
                                //    Save changes&close
                                LockFusesForm->OKButton->Width = 219;
                        }
                        break;
    case 0x1500:        //   PIC12F752
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7";            //  0
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13";           //  1
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                        LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "WRT0";         //   2  1
                        LockFusesForm->CheckBox12->Caption    = "WRT1";         //   3  1
                        LockFusesForm->CheckBox13->Caption    = "!CLKOUTEN";    //   4  1
                        LockFusesForm->CheckBox14->Caption    = "!DEBUG";       //   5  1
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox12->Visible    = true;           //   3  1
                        LockFusesForm->CheckBox13->Visible    = true;           //   4  1
                        LockFusesForm->CheckBox14->Visible    = true;           //   5  1
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 219;
                        break;
    case 0x1200:        //   PIC16F785
    case 0x1400:        //   PIC16F690
    case 0x1340:        //   PIC16F689
    case 0x1180:        //   PIC16F688
    case 0x1320:        //   PIC16F687
    case 0x04A0:        //   PIC16F685
    case 0x1080:        //   PIC16F684
    case 0x1440:        //   PIC16F677
    case 0x1420:        //   PIC16F631
    case 0x0460:        //   PIC12F683
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7";            //  0
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13";           //  1
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   2  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                        LockFusesForm->CheckBox8->Caption     = "!CPD";         //   7  0
                        LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "IESO";         //   2  1
                        LockFusesForm->CheckBox12->Caption    = "FCMEN";        //   3  1
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox12->Visible    = true;           //   3  1
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 219;
                        break;
    case 0x10A0:        //   PIC16F636 / PIC16F639
    case 0x0FA0:        //   PIC12F635
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7";            //  0
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13";           //  1
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   2  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "!CP";          //   6  0
                        LockFusesForm->CheckBox8->Caption     = "!CPD";         //   7  0
                        LockFusesForm->CheckBox9->Caption     = "BOREN0";       //   0  1
                        LockFusesForm->CheckBox10->Caption    = "BOREN1";       //   1  1
                        LockFusesForm->CheckBox11->Caption    = "IESO";         //   2  1
                        LockFusesForm->CheckBox12->Caption    = "FCMEN";        //   3  1
                        LockFusesForm->CheckBox13->Caption    = "!WURE";        //   4  1
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox10->Visible    = true;           //   1  1
                        LockFusesForm->CheckBox11->Visible    = true;           //   2  1
                        LockFusesForm->CheckBox12->Visible    = true;           //   3  1
                        LockFusesForm->CheckBox13->Visible    = true;           //   4  1
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 219;
                        break;
    case 0x10C0:        //   PIC16F630
    case 0x10E0:        //   PIC16F676
    case 0x0F80:        //   PIC12F629
    case 0x0FC0:        //   PIC12F675
                        //   
                        LockFusesForm->GroupBox1->Caption     = "bits 0..7";            //  0
                        LockFusesForm->GroupBox2->Caption     = "bits 8..13";           //  1
                        //   
                        LockFusesForm->GroupBox1->Visible     = true;           //   0
                        LockFusesForm->GroupBox2->Visible     = true;           //   1
                        //   
                        LockFusesForm->CheckBox1->Caption     = "FOSC0";        //   0  0
                        LockFusesForm->CheckBox2->Caption     = "FOSC1";        //   1  0
                        LockFusesForm->CheckBox3->Caption     = "FOSC2";        //   2  0
                        LockFusesForm->CheckBox4->Caption     = "WDTE";         //   3  0
                        LockFusesForm->CheckBox5->Caption     = "!PWRTE";       //   4  0
                        LockFusesForm->CheckBox6->Caption     = "MCLRE";        //   5  0
                        LockFusesForm->CheckBox7->Caption     = "BODEN";        //   6  0
                        LockFusesForm->CheckBox8->Caption     = "!CP";          //   7  0
                        LockFusesForm->CheckBox9->Caption     = "!CPD";         //   0  1
                        LockFusesForm->CheckBox13->Caption    = "BG0";          //   4  1
                        LockFusesForm->CheckBox14->Caption    = "BG1";          //   5  1
                        //   
                        LockFusesForm->CheckBox1->Visible     = true;           //   0  0
                        LockFusesForm->CheckBox2->Visible     = true;           //   1  0
                        LockFusesForm->CheckBox3->Visible     = true;           //   2  0
                        LockFusesForm->CheckBox4->Visible     = true;           //   3  0
                        LockFusesForm->CheckBox5->Visible     = true;           //   4  0
                        LockFusesForm->CheckBox6->Visible     = true;           //   5  0
                        LockFusesForm->CheckBox7->Visible     = true;           //   6  0
                        LockFusesForm->CheckBox8->Visible     = true;           //   7  0
                        LockFusesForm->CheckBox9->Visible     = true;           //   0  1
                        LockFusesForm->CheckBox13->Visible    = true;           //   4  1
                        LockFusesForm->CheckBox14->Visible    = true;           //   5  1
                        //    Save changes&close
                        LockFusesForm->OKButton->Width = 219; 
                        break;
    case 0:     //SendMsgToLog(14,"");            //   ,      
                break;
    default:    //SendMsgToLog(15," unknown");    //   ,    
                break;
  }
  PutDataOnCheckBoxes();                        //     
  LockFusesForm->Panel1->Visible        = true; //     
}
//---------------------------------------------------------------------------
//---      --------------------------------
//---------------------------------------------------------------------------
void PutDataOnCheckBoxes()
{ //          
  //    -  ,   - 
  switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
  { case 0x2080:        //   PIC16F887
    case 0x2060:        //   PIC16F886
    case 0x2040:        //   PIC16F884
    case 0x2020:        //   PIC16F883
    case 0x2000:        //   PIC16F882
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // !CPD = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1 = 0
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // IESO = 0
                        if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // FCMEN = 0
                        if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // LVP = 0
                        if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // !DEBUG = 0
                        if(!(SelectedChip.Area3[2*8+1]&1))  LockFusesForm->CheckBox25->Checked  = true; // BOR4V = 0
                        if(!(SelectedChip.Area3[2*8+1]&2))  LockFusesForm->CheckBox26->Checked  = true; // WRT0 = 0
                        if(!(SelectedChip.Area3[2*8+1]&4))  LockFusesForm->CheckBox27->Checked  = true; // WRT1 = 0
                        break;
    case 0x1C60:        //   PIC16LF721
    case 0x1C20:        //   PIC16F721
    case 0x1C40:        //   PIC16LF720
    case 0x1C00:        //   PIC16F720
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1 = 0
                        if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // PLLEN = 0
                        if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // !DEBUG = 0
                        if(!(SelectedChip.Area3[2*8]&1))    LockFusesForm->CheckBox17->Checked  = true; // WRT0 = 0
                        if(!(SelectedChip.Area3[2*8]&2))    LockFusesForm->CheckBox18->Checked  = true; // WRT1 = 0
                        if(!(SelectedChip.Area3[2*8]&16))   LockFusesForm->CheckBox21->Checked  = true; // VCAPEN = 0
                        break;
    case 0x1900:        //   PIC16LF727
    case 0x1800:        //   PIC16F727
    case 0x1940:        //   PIC16LF724
    case 0x1840:        //   PIC16F724
    case 0x1920:        //   PIC16LF726
    case 0x1820:        //   PIC16F726
    case 0x1B40:        //   PIC16LF723A
    case 0x1B00:        //   PIC16F723A
    case 0x1960:        //   PIC16LF723
    case 0x1860:        //   PIC16F723
    case 0x1B60:        //   PIC16LF722A
    case 0x1B20:        //   PIC16F722A
    case 0x1980:        //   PIC16LF722
    case 0x1880:        //   PIC16F722
    case 0x1AE0:        //   PIC16LF707
    case 0x1AC0:        //   PIC16F707
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1 = 0
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // BORV = 0
                        if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // PLLEN = 0
                        if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // !DEBUG = 0
                        if(!(SelectedChip.Area3[2*8]&16))   LockFusesForm->CheckBox21->Checked  = true; // VCAPEN0 = 0
                        if(!(SelectedChip.Area3[2*8]&32))   LockFusesForm->CheckBox22->Checked  = true; // VCAPEN1 = 0
                        break;
    case 0x1100:        //   PIC16F648A
    case 0x1060:        //   PIC16F628A
    case 0x1040:        //   PIC16F627A
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // BOREN = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // LVP = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // !CPD = 0
                        if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // !CP = 0
                        break;
    case 0x14A0:        //   PIC16LF1847
    case 0x1480:        //   PIC16F1847
    case 0x1BC0:        //   PIC12LF1840
    case 0x1B80:        //   PIC12F1840
    case 0x28E0:        //   PIC16LF1829
    case 0x27E0:        //   PIC16F1829
    case 0x28C0:        //   PIC16LF1828
    case 0x27C0:        //   PIC16F1828
    case 0x28A0:        //   PIC16LF1827
    case 0x27A0:        //   PIC16F1827
    case 0x2880:        //   PIC16LF1826
    case 0x2780:        //   PIC16F1826
    case 0x2860:        //   PIC16LF1825
    case 0x2760:        //   PIC16F1825
    case 0x2840:        //   PIC16LF1824
    case 0x2740:        //   PIC16F1824
    case 0x2820:        //   PIC16LF1823
    case 0x2720:        //   PIC16F1823
    case 0x2800:        //   PIC12LF1822
    case 0x2700:        //   PIC12F1822
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE0 = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // WDTE1 = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // !CPD = 0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // BOREN1 = 0
                        if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // !CLKOUTEN = 0
                        if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // IESO = 0
                        if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // FCMEN = 0
                        if(!(SelectedChip.Area3[2*8]&1))    LockFusesForm->CheckBox17->Checked  = true; // WRT0 = 0
                        if(!(SelectedChip.Area3[2*8]&2))    LockFusesForm->CheckBox18->Checked  = true; // WRT1 = 0
                        if(!(SelectedChip.Area3[2*8+1]&1))  LockFusesForm->CheckBox25->Checked  = true; // PLLEN = 0
                        if(!(SelectedChip.Area3[2*8+1]&2))  LockFusesForm->CheckBox26->Checked  = true; // STVREN = 0
                        if(!(SelectedChip.Area3[2*8+1]&4))  LockFusesForm->CheckBox27->Checked  = true; // BORV = 0
                        if(!(SelectedChip.Area3[2*8+1]&16)) LockFusesForm->CheckBox29->Checked  = true; // !DEBUG = 0
                        if(!(SelectedChip.Area3[2*8+1]&32)) LockFusesForm->CheckBox30->Checked  = true; // LVP = 0
                        break;
    case 0x1360:        //   PIC12F617
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // IOSCFS = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1 = 0
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // WRT0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // WRT1 = 0
                        break;
    case 0x1240:        //   PIC16F616
    case 0x2260:        //   PIC16F610
    case 0x2240:        //   PIC12F609
    case 0x2180:        //   PIC12F615
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // IOSCFS = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1 = 0
                        break;
    case 0x2E00:        //   PIC16LF1509
    case 0x2D40:        //   PIC16F1509
    case 0x2DE0:        //   PIC16LF1508
    case 0x2D20:        //   PIC12F1508
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE0 = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // WDTE1 = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // BOREN1 = 0
                        if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // !CLKOUTEN = 0
                        if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // IESO = 0
                        if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // FCMEN = 0
                        if(!(SelectedChip.Area3[2*8]&1))    LockFusesForm->CheckBox17->Checked  = true; // WRT0 = 0
                        if(!(SelectedChip.Area3[2*8]&2))    LockFusesForm->CheckBox18->Checked  = true; // WRT1 = 0
                        if(!(SelectedChip.Area3[2*8+1]&2))  LockFusesForm->CheckBox26->Checked  = true; // STVREN = 0
                        if(!(SelectedChip.Area3[2*8+1]&4))  LockFusesForm->CheckBox27->Checked  = true; // BORV = 0
                        if(!(SelectedChip.Area3[2*8+1]&8))  LockFusesForm->CheckBox28->Checked  = true; // !LPBOR = 0
                        if(!(SelectedChip.Area3[2*8+1]&16)) LockFusesForm->CheckBox29->Checked  = true; // !DEBUG = 0
                        if(!(SelectedChip.Area3[2*8+1]&32)) LockFusesForm->CheckBox30->Checked  = true; // LVP = 0
                        break;
    case 0x2DC0:        //   PIC16LF1507
    case 0x2D00:        //   PIC16F1507
    case 0x2DA0:        //   PIC16LF1503
    case 0x2CE0:        //   PIC16F1503
    case 0x2D80:        //   PIC12LF1501
    case 0x2CC0:        //   PIC12F1501
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE0 = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // WDTE1 = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // BOREN1 = 0
                        if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // !CLKOUTEN = 0
                        if(!(SelectedChip.Area3[2*8]&1))    LockFusesForm->CheckBox17->Checked  = true; // WRT0 = 0
                        if(!(SelectedChip.Area3[2*8]&2))    LockFusesForm->CheckBox18->Checked  = true; // WRT1 = 0
                        if(!(SelectedChip.Area3[2*8+1]&2))  LockFusesForm->CheckBox26->Checked  = true; // STVREN = 0
                        if(!(SelectedChip.Area3[2*8+1]&4))  LockFusesForm->CheckBox27->Checked  = true; // BORV = 0
                        if(!(SelectedChip.Area3[2*8+1]&8))  LockFusesForm->CheckBox28->Checked  = true; // !LPBOR = 0
                        if(!(SelectedChip.Area3[2*8+1]&32)) LockFusesForm->CheckBox30->Checked  = true; // LVP = 0
                        break;
     case 0x3020:     //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                                if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                                if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                                if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                                if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                                if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0
                                if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1
                                if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // WRT0
                                if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // WRT1
                                if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // !CLKOUTEN
                                if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // !DEBUG
                        }
                        break;
    case 0x1500:        //   PIC12F752
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // WRT0
                        if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // WRT1
                        if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // !CLKOUTEN
                        if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // !DEBUG
                        break;
    case 0x1200:        //   PIC16F785
    case 0x1400:        //   PIC16F690
    case 0x1340:        //   PIC16F689
    case 0x1180:        //   PIC16F688
    case 0x1320:        //   PIC16F687
    case 0x04A0:        //   PIC16F685
    case 0x1080:        //   PIC16F684
    case 0x1440:        //   PIC16F677
    case 0x1420:        //   PIC16F631
    case 0x0460:        //   PIC12F683
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // !CPD = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // IESO
                        if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // FCMEN
                        break;
    case 0x10A0:        //   PIC16F636 / PIC16F639
    case 0x0FA0:        //   PIC12F635
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // !CPD = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // BOREN0
                        if(!(SelectedChip.Area3[2*7+1]&2))  LockFusesForm->CheckBox10->Checked  = true; // BOREN1
                        if(!(SelectedChip.Area3[2*7+1]&4))  LockFusesForm->CheckBox11->Checked  = true; // IESO
                        if(!(SelectedChip.Area3[2*7+1]&8))  LockFusesForm->CheckBox12->Checked  = true; // FCMEN
                        if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // !WURE
                        break;
    case 0x10C0:        //   PIC16F630
    case 0x10E0:        //   PIC16F676
    case 0x0F80:        //   PIC12F629
    case 0x0FC0:        //   PIC12F675
                        if(!(SelectedChip.Area3[2*7]&1))    LockFusesForm->CheckBox1->Checked   = true; // FOSC0 = 0
                        if(!(SelectedChip.Area3[2*7]&2))    LockFusesForm->CheckBox2->Checked   = true; // FOSC1 = 0
                        if(!(SelectedChip.Area3[2*7]&4))    LockFusesForm->CheckBox3->Checked   = true; // FOSC2 = 0
                        if(!(SelectedChip.Area3[2*7]&8))    LockFusesForm->CheckBox4->Checked   = true; // WDTE = 0
                        if(!(SelectedChip.Area3[2*7]&16))   LockFusesForm->CheckBox5->Checked   = true; // !PWRTE = 0
                        if(!(SelectedChip.Area3[2*7]&32))   LockFusesForm->CheckBox6->Checked   = true; // MCLRE = 0
                        if(!(SelectedChip.Area3[2*7]&64))   LockFusesForm->CheckBox7->Checked   = true; // BODEN = 0
                        if(!(SelectedChip.Area3[2*7]&128))  LockFusesForm->CheckBox8->Checked   = true; // !CP = 0
                        if(!(SelectedChip.Area3[2*7+1]&1))  LockFusesForm->CheckBox9->Checked   = true; // !CPD = 0
                        if(!(SelectedChip.Area3[2*7+1]&16)) LockFusesForm->CheckBox13->Checked  = true; // BG0 = 0
                        if(!(SelectedChip.Area3[2*7+1]&32)) LockFusesForm->CheckBox14->Checked  = true; // BG1 = 0
                        break;
    case 0:
    default:    break;
  }
}
//---------------------------------------------------------------------------
//---       -------------------------
//---------------------------------------------------------------------------
void GetDataFromCheckBoxes()
{ //        ,    
  switch(Form1->PageControl1->TabIndex)
  {     case 0: GetDataToMemory(6,3);      //  RichEdit6  Area3
                break;
        case 1: GetDataToMemory(7,3);      //  RichEdit7  Area3
                break;
        default: break;
  }
  //           
  //    -  ,   - 
  switch(SelectedChip.ID&0x3FE0)     //  5      (  ,   )
  { case 0x2080:        //   PIC16F887
    case 0x2060:        //   PIC16F886
    case 0x2040:        //   PIC16F884
    case 0x2020:        //   PIC16F883
    case 0x2000:        //   PIC16F882
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        SelectedChip.Area3[16] = 0xFF;   //       
                        SelectedChip.Area3[17] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // |CPD = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // IESO = 0
                        if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // FCMEN = 0
                        if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // PLLEN = 0
                        if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // |DEBUG = 0
                        if(LockFusesForm->CheckBox25->Checked) SelectedChip.Area3[2*8+1] &= ~1;   // BOR4V = 0
                        if(LockFusesForm->CheckBox26->Checked) SelectedChip.Area3[2*8+1] &= ~2;   // WRT0 = 0
                        if(LockFusesForm->CheckBox27->Checked) SelectedChip.Area3[2*8+1] &= ~4;   // WRT1 = 0
                        break;
    case 0x1C60:        //   PIC16LF721
    case 0x1C20:        //   PIC16F721
    case 0x1C40:        //   PIC16LF720
    case 0x1C00:        //   PIC16F720
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3C;
                        SelectedChip.Area3[16] = 0xFF;   //       
                        SelectedChip.Area3[17] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // PLLEN = 0
                        if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // |DEBUG = 0
                        if(LockFusesForm->CheckBox17->Checked) SelectedChip.Area3[2*8]   &= ~1;   // WRT0 = 0
                        if(LockFusesForm->CheckBox18->Checked) SelectedChip.Area3[2*8]   &= ~2;   // WRT1 = 0
                        if(LockFusesForm->CheckBox21->Checked) SelectedChip.Area3[2*8]   &= ~16;  // VCAPEN = 0
                        break;
    case 0x1900:        //   PIC16LF727
    case 0x1800:        //   PIC16F727
    case 0x1940:        //   PIC16LF724
    case 0x1840:        //   PIC16F724
    case 0x1920:        //   PIC16LF726
    case 0x1820:        //   PIC16F726
    case 0x1B40:        //   PIC16LF723A
    case 0x1B00:        //   PIC16F723A
    case 0x1960:        //   PIC16LF723
    case 0x1860:        //   PIC16F723
    case 0x1B60:        //   PIC16LF722A
    case 0x1B20:        //   PIC16F722A
    case 0x1980:        //   PIC16LF722
    case 0x1880:        //   PIC16F722
    case 0x1AE0:        //   PIC16LF707
    case 0x1AC0:        //   PIC16F707
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        SelectedChip.Area3[16] = 0xFF;   //       
                        SelectedChip.Area3[17] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // BORV = 0
                        if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // PLLEN = 0
                        if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // |DEBUG = 0
                        if(LockFusesForm->CheckBox21->Checked) SelectedChip.Area3[2*8]   &= ~16;  // VCAPEN0 = 0
                        if(LockFusesForm->CheckBox22->Checked) SelectedChip.Area3[2*8]   &= ~32;  // VCAPEN1 = 0
                        break;
    case 0x1100:        //   PIC16F648A
    case 0x1060:        //   PIC16F628A
    case 0x1040:        //   PIC16F627A
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // WDTE = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // |PWRTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // FOSC2 = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // BOREN = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // LVP = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // |CPD = 0
                        if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // |CP = 0
                        break;
    case 0x14A0:        //   PIC16LF1847
    case 0x1480:        //   PIC16F1847
    case 0x1BC0:        //   PIC12LF1840
    case 0x1B80:        //   PIC12F1840
    case 0x28E0:        //   PIC16LF1829
    case 0x27E0:        //   PIC16F1829
    case 0x28C0:        //   PIC16LF1828
    case 0x27C0:        //   PIC16F1828
    case 0x28A0:        //   PIC16LF1827
    case 0x27A0:        //   PIC16F1827
    case 0x2880:        //   PIC16LF1826
    case 0x2780:        //   PIC16F1826
    case 0x2860:        //   PIC16LF1825
    case 0x2760:        //   PIC16F1825
    case 0x2840:        //   PIC16LF1824
    case 0x2740:        //   PIC16F1824
    case 0x2820:        //   PIC16LF1823
    case 0x2720:        //   PIC16F1823
    case 0x2800:        //   PIC12LF1822
    case 0x2700:        //   PIC12F1822
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        SelectedChip.Area3[16] = 0xFF;   //       
                        SelectedChip.Area3[17] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE0 = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // WDTE1 = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // MCLRE = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // |CP = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // |CPD = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // |CLKOUTEN = 0
                        if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // IESO = 0
                        if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // FCMEN = 0
                        if(LockFusesForm->CheckBox17->Checked) SelectedChip.Area3[2*8]   &= ~1;   // WRT0 = 0
                        if(LockFusesForm->CheckBox18->Checked) SelectedChip.Area3[2*8]   &= ~2;   // WRT1 = 0
                        if(LockFusesForm->CheckBox25->Checked) SelectedChip.Area3[2*8+1] &= ~1;   // PLLEN = 0
                        if(LockFusesForm->CheckBox26->Checked) SelectedChip.Area3[2*8+1] &= ~2;   // STVREN = 0
                        if(LockFusesForm->CheckBox27->Checked) SelectedChip.Area3[2*8+1] &= ~4;   // BORV = 0
                        if(LockFusesForm->CheckBox29->Checked) SelectedChip.Area3[2*8+1] &= ~16;  // |DEBUG = 0
                        if(LockFusesForm->CheckBox30->Checked) SelectedChip.Area3[2*8+1] &= ~32;  // LVP = 0
                        break;
    case 0x1360:        //   PIC12F617
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // IOSCFS = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // WRT0 = 0
                        if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // WRT1 = 0
                        break;
    case 0x1240:        //   PIC16F616
    case 0x2260:        //   PIC16F610
    case 0x2240:        //   PIC12F609
    case 0x2180:        //   PIC12F615
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // IOSCFS = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                        break;
    case 0x2E00:        //   PIC16LF1509
    case 0x2D40:        //   PIC16F1509
    case 0x2DE0:        //   PIC16LF1508
    case 0x2D20:        //   PIC12F1508
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        SelectedChip.Area3[16] = 0xFF;   //       
                        SelectedChip.Area3[17] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE0 = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // WDTE1 = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // MCLRE = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // |CP = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // |CLKOUTEN = 0
                        if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // IESO = 0
                        if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // FCMEN = 0
                        if(LockFusesForm->CheckBox17->Checked) SelectedChip.Area3[2*8]   &= ~1;   // WRT0 = 0
                        if(LockFusesForm->CheckBox18->Checked) SelectedChip.Area3[2*8]   &= ~2;   // WRT1 = 0
                        if(LockFusesForm->CheckBox26->Checked) SelectedChip.Area3[2*8+1] &= ~2;   // STVREN = 0
                        if(LockFusesForm->CheckBox27->Checked) SelectedChip.Area3[2*8+1] &= ~4;   // BORV = 0
                        if(LockFusesForm->CheckBox28->Checked) SelectedChip.Area3[2*8+1] &= ~8;   // |LPBOR = 0
                        if(LockFusesForm->CheckBox29->Checked) SelectedChip.Area3[2*8+1] &= ~16;  // |DEBUG = 0
                        if(LockFusesForm->CheckBox30->Checked) SelectedChip.Area3[2*8+1] &= ~32;  // LVP = 0
                        break;
    case 0x2DC0:        //   PIC16LF1507
    case 0x2D00:        //   PIC16F1507
    case 0x2DA0:        //   PIC16LF1503
    case 0x2CE0:        //   PIC16F1503
    case 0x2D80:        //   PIC12LF1501
    case 0x2CC0:        //   PIC12F1501
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        SelectedChip.Area3[16] = 0xFF;   //       
                        SelectedChip.Area3[17] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE0 = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // WDTE1 = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // MCLRE = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // |CP = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // |CLKOUTEN = 0
                        if(LockFusesForm->CheckBox17->Checked) SelectedChip.Area3[2*8]   &= ~1;   // WRT0 = 0
                        if(LockFusesForm->CheckBox18->Checked) SelectedChip.Area3[2*8]   &= ~2;   // WRT1 = 0
                        if(LockFusesForm->CheckBox26->Checked) SelectedChip.Area3[2*8+1] &= ~2;   // STVREN = 0
                        if(LockFusesForm->CheckBox27->Checked) SelectedChip.Area3[2*8+1] &= ~4;   // BORV = 0
                        if(LockFusesForm->CheckBox28->Checked) SelectedChip.Area3[2*8+1] &= ~8;   // |LPBOR = 0
                        if(LockFusesForm->CheckBox30->Checked) SelectedChip.Area3[2*8+1] &= ~32;  // LVP = 0
                        break;
    case 0x3020:     //   PIC16F753
                        if(SelectedChip.ID == 0x3030)       //    PIC16F753
                        {       SelectedChip.Area3[14] = 0xFF;   //       
                                SelectedChip.Area3[15] = 0x3F;
                                if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                                if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                                if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                                if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                                if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                                if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                                if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                                if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // WRT0 = 0
                                if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // WRT1 = 0
                                if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // !CLKOUTEN = 0
                                if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // !DEBUG = 0
                        }
                        break;
    case 0x1500:        //   PIC12F752
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // WRT0 = 0
                        if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // WRT1 = 0
                        if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // !CLKOUTEN = 0
                        if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // !DEBUG = 0
                        break;
    case 0x1200:        //   PIC16F785
    case 0x1400:        //   PIC16F690
    case 0x1340:        //   PIC16F689
    case 0x1180:        //   PIC16F688
    case 0x1320:        //   PIC16F687
    case 0x04A0:        //   PIC16F685
    case 0x1080:        //   PIC16F684
    case 0x1440:        //   PIC16F677
    case 0x1420:        //   PIC16F631
    case 0x0460:        //   PIC12F683
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // |CPD = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // IESO = 0
                        if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // FCMEN = 0
                        break;
    case 0x10A0:        //   PIC16F636 / PIC16F639
    case 0x0FA0:        //   PIC12F635
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x3F;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // |CP = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // |CPD = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // BOREN0 = 0
                        if(LockFusesForm->CheckBox10->Checked) SelectedChip.Area3[2*7+1] &= ~2;   // BOREN1 = 0
                        if(LockFusesForm->CheckBox11->Checked) SelectedChip.Area3[2*7+1] &= ~4;   // IESO = 0
                        if(LockFusesForm->CheckBox12->Checked) SelectedChip.Area3[2*7+1] &= ~8;   // FCMEN = 0
                        if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // |WURE = 0
                        break;
    case 0x10C0:        //   PIC16F630
    case 0x10E0:        //   PIC16F676
    case 0x0F80:        //   PIC12F629
    case 0x0FC0:        //   PIC12F675
                        SelectedChip.Area3[14] = 0xFF;   //       
                        SelectedChip.Area3[15] = 0x31;
                        if(LockFusesForm->CheckBox1->Checked)  SelectedChip.Area3[2*7]   &= ~1;   // FOSC0 = 0 ( )
                        if(LockFusesForm->CheckBox2->Checked)  SelectedChip.Area3[2*7]   &= ~2;   // FOSC1 = 0
                        if(LockFusesForm->CheckBox3->Checked)  SelectedChip.Area3[2*7]   &= ~4;   // FOSC2 = 0
                        if(LockFusesForm->CheckBox4->Checked)  SelectedChip.Area3[2*7]   &= ~8;   // WDTE = 0
                        if(LockFusesForm->CheckBox5->Checked)  SelectedChip.Area3[2*7]   &= ~16;  // |PWRTE = 0
                        if(LockFusesForm->CheckBox6->Checked)  SelectedChip.Area3[2*7]   &= ~32;  // MCLRE = 0
                        if(LockFusesForm->CheckBox7->Checked)  SelectedChip.Area3[2*7]   &= ~64;  // BODEN = 0
                        if(LockFusesForm->CheckBox8->Checked)  SelectedChip.Area3[2*7]   &= ~128; // |CP = 0
                        if(LockFusesForm->CheckBox9->Checked)  SelectedChip.Area3[2*7+1] &= ~1;   // |CPD = 0
                        if(LockFusesForm->CheckBox13->Checked) SelectedChip.Area3[2*7+1] &= ~16;  // BG0 = 0
                        if(LockFusesForm->CheckBox14->Checked) SelectedChip.Area3[2*7+1] &= ~32;  // BG1 = 0
                        break;
    case 0:
    default:    break;
  }
  //       (   )
  switch(Form1->PageControl1->TabIndex)
  {     case 0: PlaceDataToForm(6,3);      //  RichEdit6  Area3
                break;
        case 1: PlaceDataToForm(7,3);      //  RichEdit7  Area3
                break;
        default: break;
  }
}
//---------------------------------------------------------------------------
//---      --------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TLockFusesForm::OKButtonClick(TObject *Sender)
{ GetDataFromCheckBoxes();      //          
  Close();
}
//---------------------------------------------------------------------------

