//---------------------------------------------------------------------------
#ifndef PICFunctionsH
#define PICFunctionsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//--- ,       ---------------
//---------------------------------------------------------------------------
#define PORTC_WORK      0x8     // 0000 1000 ( +12, +5 = 10    ,   = 0)
#define DDRC_WORK       0x3C    // 0011 1100 (+12, +5, Clock, DataOut - ,  - )
//---------------------------------------------------------------------------
//--- ,     -----------------------------
//---------------------------------------------------------------------------
//---   C ---
#define Clock   5
#define DataOut 4
#define V12     3
#define V5      2
#define DataIn  0
//---------------------------------------------------------------------------
//---   ---------------------------------------------------------
//---------------------------------------------------------------------------
bool SetInitState(void);                //       
bool EnterHVPVMode_VPPfirst(void);      //        Vpp-first
bool EnterHVPVMode_VDDfirst(void);      //        Vdd-first
bool ExitHVPVMode_VPPlast(void);        //        Vpp-last
bool ExitHVPVMode_VDDlast(void);        //        Vdd-last
unsigned int ReadSignatureBytes(void);  //   
//---------------------------------------------------------------------------
#endif
