//---------------------------------------------------------------------------
#ifndef pic16f630H
#define pic16f630H
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
//---   ---------------------------------------------------------
//---------------------------------------------------------------------------
bool PIC16F630_SetPCToConfigMemory(void);                               //      
bool PIC16F630_MakePCOffset(unsigned int Offset, bool PB);              //       (PB = 0 -   -, PB = 1 -  -)
bool PIC16F630_ReadProgramMemory(unsigned int Address, bool Action);    // /     
bool PIC16F630_ReadConfigMemory(unsigned int Address, bool Action);     // /     
bool PIC16F630_ReadConfigMemoryMask(unsigned int Address, unsigned short Mask); //      ,    ( )
bool PIC16F630_ReadDataMemory(unsigned int Address, bool Action);       // /     
bool PIC16F630_WriteProgramMemory(unsigned int Address, bool Action);   //       (Action=0 - Internally timed, Action=1 - Externally timed)
bool PIC16F630_WriteConfigMemory(unsigned int Address, bool Action);    //       (Action=0 - Internally timed, Action=1 - Externally timed)
bool PIC16F630_WriteDataMemory(unsigned int Address, bool Action);      //       (Action=0 - Internally timed, Action=1 - Externally timed)
bool PIC16F630_LoadDataToProgramMemory(unsigned short Data);            //     
bool PIC16F630_BulkEraseProgramMemory(void);                            //   /
bool PIC16F630_BulkEraseDataMemory(void);                               //   
//---------------------------------------------------------------------------
#endif
